/**
 * Created by garrett on 23/07/2014.
 */


diaryServices.factory('Configuration', function ($location,$log) {
    var configuration = {};

    var runningInBackground = false;

    
    var authenticationPostEndPoint = '/BusinessLogicServices/api/authentication/usernamepassword';
    var customerListEndPoint = '/BusinessLogicServices/api/businessentity/getall';
    var siteListEndpoint = '/BusinessLogicServices/api/businessentity/getsiteaddressfor/';
    var priorityListEndpoint = '/BusinessLogicServices/api/action/priority/getall/';
    var actionTypeListEndpoint = '/BusinessLogicServices/api/action/actiontype/webdiary/getall/';
    var requestListEndpoint = '/BusinessLogicServices/api/webdiary/request/getall/';
    var requestListSearchEndpoint = '/BusinessLogicServices/api/webdiary/request/search';
    var runCategoryEndPoint = '/BusinessLogicServices/api/webdiary/runcategory/getall';
    var createRequestEndpoint = '/BusinessLogicServices/api/webdiary/request/create/';
    var deleteRequestEndpoint = '/BusinessLogicServices/api/webdiary/request/delete/';
    var contactListEndpoint ='/BusinessLogicServices/api/businessentity/personsforbusinessentity/';
    var employeeListEndpoint ='/BusinessLogicServices/api/businessentity/personsforcompanybusinessentity/';
    var createActionEndpoint = '/BusinessLogicServices/api/action/create/';
    var deleteActionEndpoint = '/BusinessLogicServices/api/action/delete/';
    var requestSearchEndpoint = '/BusinessLogicServices/api/webdiary/request/search/';
    var requestTypeEndpoint = '/BusinessLogicServices/api/webdiary/requesttype/getall/';
	var actionSearchEndpoint = '/BusinessLogicServices/api/action/getall/search';

    // reports
    var runScheduleReportEndpoint = '/BusinessLogicServices/api/webdiary/report/runschedule';
    
    // initialize when app starts

    var init = function(){
        configuration.username= localStorage.username;
        configuration.password= localStorage.password;
        configuration.jsonwebtoken= localStorage.jsonwebtoken;
        configuration.operatorId = localStorage.operatorId;
        configuration.operatorName = localStorage.operatorName;
        configuration.clientconfig = parseInt(localStorage.clientconfig);
        
        //configuration.apikey = localStorage.apikey;
        //configuration.jsonwebtoken = localStorage.jsonwebtoken;
        
        //console.log("localStorageOperator is");
        //console.log(localStorage.selectedOperator );
        //configuration.selectedOperator = localStorage.selectedOperator;
        
        //console.log("localStorageDepot is");
        //console.log(localStorage.selectedDepot );
        //configuration.selectedDepot = localStorage.selectedDepot;
        
        configuration.baseURL = getBaseURL();
        
        configuration.authenticationPostURL = configuration.baseURL + authenticationPostEndPoint;
        configuration.customerListUrl = configuration.baseURL + customerListEndPoint;
        configuration.siteListUrl = configuration.baseURL + siteListEndpoint;
        configuration.priorityListUrl = configuration.baseURL + priorityListEndpoint;
        configuration.actionTypeListUrl = configuration.baseURL + actionTypeListEndpoint;
        configuration.requestListUrl = configuration.baseURL + requestListEndpoint;
        configuration.requestListSearchUrl = configuration.baseURL + requestListSearchEndpoint;
        configuration.runCategoryListUrl = configuration.baseURL +  runCategoryEndPoint;
        configuration.createRequestUrl = configuration.baseURL +  createRequestEndpoint;
        configuration.deleteRequestUrl = configuration.baseURL +  deleteRequestEndpoint;
        configuration.contactListUrl = configuration.baseURL +  contactListEndpoint;
        configuration.employeeListUrl = configuration.baseURL + employeeListEndpoint;
        configuration.createActionListUrl = configuration.baseURL + createActionEndpoint;
        configuration.deleteActionUrl = configuration.baseURL + deleteActionEndpoint;
        configuration.requestSearchUrl = configuration.baseURL + requestSearchEndpoint;
        configuration.requestTypeUrl = configuration.baseURL + requestTypeEndpoint;
        configuration.runScheduleReportUrl = configuration.baseURL + runScheduleReportEndpoint;
        configuration.actionSearchUrl = configuration.baseURL + actionSearchEndpoint;
        
        $log.info("configuration.authenticationPostURL = " + configuration.authenticationPostURL);
    };
    
    var getBaseURL = function(){
        var portURL = "";
        if( $location.port() !== '80' ){
            portURL=":" + $location.port();
        }
        //return $location.protocol() + "://" + $location.host() + portURL;
        
        return "http://jpoint.dynalias.net:9091";
    };

    getConfiguration = function(){
        return configuration;
    };
    
    saveLoginConfiguration = function(){
        //localStorage.apikey = configuration.apikey  ;
        localStorage.jsonwebtoken = configuration.jsonwebtoken  ;
        localStorage.username = configuration.username;
        localStorage.password = configuration.password;
        localStorage.operatorId = configuration.operatorId;
        localStorage.operatorName = configuration.operatorName;
        localStorage.clientconfig = configuration.clientconfig;
    };
    clearLoginConfiguration = function(){
        configuration.jsonwebtoken="";
        configuration.username="";
        configuration.password="";
        configuration.operatorId=0;
        configuration.operatorName="";
        configuration.clientconfig=0;
        saveLoginConfiguration();
    };
    

    return{
        initialize : init,
        getConfiguration : getConfiguration,
        runningInBackground : runningInBackground,
        saveLoginConfiguration : saveLoginConfiguration,
        clearLoginConfiguration: clearLoginConfiguration
    };
});

